#include "DebugClass.h"

DebugClass::DebugClass() {
	fColor_space = BScreen().ColorSpace();
	_InitialFormat();
}


DebugClass::~DebugClass() {
}


void
DebugClass::TestMethod() {
	do {
		fData = new BMallocIO();
		fMediaFile = new BMediaFile(fData, &fMediaFileFormat);
		fMediaTrack = fMediaFile->CreateTrack(&fInputFormat, &fCodec);
		fMediaFile->CommitHeader();
		fMediaTrack->SetQuality(1.0);
		
		fMediaFile->ReleaseAllTracks();
		fMediaFile->CloseFile();
		delete fMediaFile;
		delete fData;
		snooze(1000);
	}while(true);
}


void
DebugClass::CreateMediaFile() {
}


void
DebugClass::_InitialFormat() {
	memset(&fInputFormat, 0, sizeof(media_format));
		
	fInputFormat.type = B_MEDIA_RAW_VIDEO;
	fInputFormat.u.raw_video.display.line_width = 1280;
	fInputFormat.u.raw_video.display.line_count = 1024;
	fInputFormat.u.raw_video.last_active = fInputFormat.u.raw_video.display.line_count - 1;
	
	size_t pixelChunk;
	size_t rowAlign;
	size_t pixelPerChunk;
	get_pixel_size_for(fColor_space, &pixelChunk, &rowAlign, &pixelPerChunk);
	fInputFormat.u.raw_video.display.bytes_per_row = 1280 * rowAlign;			
	fInputFormat.u.raw_video.display.format = fColor_space;
	fInputFormat.u.raw_video.interlace = 1;	
	
	fInputFormat.u.raw_video.field_rate = 10;
	fInputFormat.u.raw_video.pixel_width_aspect = 1;
	fInputFormat.u.raw_video.pixel_height_aspect = 1;
	
	int32 cookie = 0;
	while(get_next_file_format(&cookie, &fMediaFileFormat) == B_OK) {
		if (fMediaFileFormat.family == B_AVI_FORMAT_FAMILY) {
			break;
		}
	}
	
	cookie = 0;
	media_format dummyFormat;
	while(get_next_encoder(&cookie, &fMediaFileFormat, &fInputFormat, &dummyFormat, &fCodec) == B_OK) {
		if(strcmp(fCodec.short_name, "mpeg4") == 0) {
			break;
		}
	}
}